// Twist32Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Twist32.h"
#include "Twist32Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwist32Dlg dialog

CTwist32Dlg::CTwist32Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTwist32Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTwist32Dlg)
	m_dAngle = 0.0;
	//}}AFX_DATA_INIT
	m_bFileOpen = FALSE;    
	m_pInputFile = NULL;
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CTwist32Dlg::~CTwist32Dlg()
{
	TidyUp(m_pInputFile);
}


void CTwist32Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTwist32Dlg)
	DDX_Text(pDX, IDC_ANGLE, m_dAngle);
	DDV_MinMaxDouble(pDX, m_dAngle, -360., 360.);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTwist32Dlg, CDialog)
	//{{AFX_MSG_MAP(CTwist32Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_CALCULATE, OnCalculate)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_HELP_BUTTON, OnHelpButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwist32Dlg message handlers

BOOL CTwist32Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTwist32Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTwist32Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTwist32Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTwist32Dlg::OnOpen() 
{
	TRACE("\nEntering OnOpen handler");

	if(m_pInputFile != NULL) 
	{
		TRACE("\nFile already open");
		if(AfxMessageBox("You have a PCB file open already.  OK to close?", MB_YESNO, 0) == IDNO)
		{
			TRACE("\nLeaving OnOpen handler");
			return;
		}
		else
		{
			TRACE("\nClosing input file");  
			TidyUp(m_pInputFile);
		}
	}  
	
	static char BASED_CODE fileDialogFilter[] =
	"PCB files (*.pcb)|*.pcb|All Files (*.*)|*.*||"; 
	
	const char fileDialogExt[] = "pcb"; 
	
	CFileDialog fileDialog(TRUE, fileDialogExt, NULL, OFN_FILEMUSTEXIST, fileDialogFilter);
		 
	if( fileDialog.DoModal() == IDOK )
	{   
		CFileException exception;
		BOOL status;
		
		m_pInputFile = new CStdioFile;
		                              
		status = m_pInputFile->Open((const char*)fileDialog.GetPathName(), CFile::modeRead, &exception); 
		
		if(!status)        // file not opened
		{
			char s[100];
			
			sprintf(s, "Error opening file for reading.  Code: %d", exception.m_cause);
			AfxMessageBox(s, MB_OK, 0);
			TidyUp(m_pInputFile);
			return;
		}
		else               // file opened, but is it correct???
		{  
			char buffer[81];
			CString cs(m_pInputFile->ReadString(buffer, 80));    // read first line
			
			if(!((cs == "PCB FILE 4\n") || (cs == "PCB FILE 5\n")))  // check first line
			{
				char s[100];
				
				sprintf(s, "Input file is not an Easytrax or Autotrax file.");
				
				AfxMessageBox(s, MB_OK | MB_ICONEXCLAMATION, 0);
				TRACE("\nFirst line is %s\n",(const char*)cs);
				
				TidyUp(m_pInputFile);
			}
			else 
			{
				m_sInputFileName = fileDialog.GetFileName();  
				GetDlgItem(IDC_CALCULATE)->EnableWindow(TRUE);  
			}
				
     	} 
   }
	return;
}

void CTwist32Dlg::TidyUp(CStdioFile*& pFile)
{
	ASSERT_VALID(pFile);
	if(pFile == NULL)
		return;
	pFile->Close();    // tidy up  
	delete pFile;
	pFile = NULL;   
	ASSERT(pFile == NULL);
}  

#include <math.h> 

void CTwist32Dlg::CalcNewPoint(int x, int y, int& newX, int& newY, double dAngle)
{
	double dRadAngle = dAngle * 3.141359265 / 180.0;
	double dA = cos(dRadAngle);
	double dB = sin(dRadAngle);
	double dC = -sin(dRadAngle);
	double dD = cos(dRadAngle);
	double dNewX, dNewY;  
	dNewX = dA * (double) x + dB * (double) y;
	dNewY = dC * (double) x + dD * (double) y;
	// observe rounding rules	
	if(dNewX > 0)
		newX = (int)(dNewX + 0.5);
	else
		newX = (int)(dNewX - 0.5);
	if(dNewY > 0)
		newY = (int)(dNewY + 0.5);
	else
		newY = (int)(dNewY - 0.5);
	return;
}

void CTwist32Dlg::OnCalculate() 
{
	TRACE("\nEntering OnCalculate handler\n"); 
	ASSERT_VALID(m_pInputFile);
	m_pInputFile->SeekToBegin();
	char buffer[64]; 
	char outbuf[64]; 
//	CMemFile memFile; 
	CString cs;
	int p1, p2, p3, p4, p5, p6, p7, p8;	// storage for other data parameters   
	int nNewX1, nNewX2, nNewY1, nNewY2;
	UpdateData(TRUE);
	int nSpaceCount = 0;				// to pick out the strings for the comment and 
	BOOL bDoNextOne = FALSE;  
	int nMinX = 0;
	int nMinY = 0; 
	int nOffsetX, nOffsetY;

	CStdioFile tempFile, outFile;
	CFileException exception;
	BOOL status;
	BOOL bDone = false;
	AfxGetApp()->DoWaitCursor(1);
	status = tempFile.Open("~~TEMP.PCB", CFile::modeCreate | CFile::modeWrite, &exception); 

	do
	{
		cs = CString(m_pInputFile->ReadString(buffer, 40));    // read next line
		if(cs.IsEmpty())
			break; 
		if(cs.Find("ENDPCB") >= 0)
			bDone = true; 
		if(bDoNextOne)	// this deals with the reference point of components
		{
			sscanf((const char*) cs, "%d %d %d %d %d", &p1, &p2, &p3, &p4, &p5);
			CalcNewPoint(p1, p2, nNewX1, nNewY1, m_dAngle);
			sprintf(outbuf, "%d %d %d %d %d\n", nNewX1, nNewY1, p3, p4, p5);
			if(nNewX1 < nMinX) nMinX = nNewX1;
			if(nNewY1 < nMinY) nMinY = nNewY1;
			tempFile.WriteString(outbuf); 
			bDoNextOne = FALSE; 
			nSpaceCount = 0;
			continue;
		} 
		if(cs.Left(1) == " ")
		{
			nSpaceCount++;
			if(nSpaceCount == 2)
				bDoNextOne = TRUE;
			sscanf((const char*) cs, " %d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6);
			CalcNewPoint(p1, p2, nNewX1, nNewY1, m_dAngle);
			sprintf(outbuf, " %d %d %d %d %d %d\n", nNewX1, nNewY1, p3, p4, p5, p6);
			if(nNewX1 < nMinX) nMinX = nNewX1;
			if(nNewY1 < nMinY) nMinY = nNewY1;
			tempFile.WriteString(outbuf); 
			continue;
		}			
		if((cs.Left(3) == "CA\n") || (cs.Left(3) == "FA\n"))    // arcs
		{
			m_pInputFile->ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6);  
			CalcNewPoint(p1, p2, nNewX1, nNewY1, m_dAngle);
			sprintf(outbuf, "%d %d %d %d %d %d\n", nNewX1, nNewY1, p3, p4, p5, p6);  
			if(nNewX1 < nMinX) nMinX = nNewX1;
			if(nNewY1 < nMinY) nMinY = nNewY1;
			tempFile.WriteString((const char*) cs);
			tempFile.WriteString(outbuf); 
			continue;			
		} 
		if((cs.Left(3) == "CV\n") || (cs.Left(3) == "FV\n"))    // vias
		{
			m_pInputFile->ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d", &p1, &p2, &p3, &p4);
			CalcNewPoint(p1, p2, nNewX1, nNewY1, m_dAngle);
			sprintf(outbuf, "%d %d %d %d\n", nNewX1, nNewY1, p3, p4);  
			if(nNewX1 < nMinX) nMinX = nNewX1;
			if(nNewY1 < nMinY) nMinY = nNewY1;
			tempFile.WriteString((const char*) cs);			
			tempFile.WriteString(outbuf); 
			continue;			
					
		}
		if((cs.Left(3) == "CT\n") || (cs.Left(3) == "FT\n"))     // tracks
		{		
			m_pInputFile->ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6, &p7);
			CalcNewPoint(p1, p2, nNewX1, nNewY1, m_dAngle);
			CalcNewPoint(p3, p4, nNewX2, nNewY2, m_dAngle);
			sprintf(outbuf, "%d %d %d %d %d %d %d\n", nNewX1, nNewY1, nNewX2, nNewY2, p5, p6, p7);  
			if(nNewX1 < nMinX) nMinX = nNewX1;
			if(nNewY1 < nMinY) nMinY = nNewY1;
			tempFile.WriteString((const char*) cs);
			tempFile.WriteString(outbuf); 
			continue;			
		}
		else if((cs.Left(3) == "CS\n") || (cs.Left(3) == "FS\n"))      // strings
		{
			m_pInputFile->ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6);
			CalcNewPoint(p1, p2, nNewX1, nNewY1, m_dAngle);
			sprintf(outbuf, "%d %d %d %d %d %d\n", nNewX1, nNewY1, p3, p4, p5, p6);  
			if(nNewX1 < nMinX) nMinX = nNewX1;
			if(nNewY1 < nMinY) nMinY = nNewY1;
			tempFile.WriteString((const char*) cs);
			tempFile.WriteString(outbuf); 
			m_pInputFile->ReadString(buffer, 40);    // throw away useless line   
			tempFile.WriteString(buffer);
			continue;			
		}
		if((cs.Left(3) == "CP\n") || (cs.Left(3) == "FP\n"))
		{
			m_pInputFile->ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6, &p7, &p8);
			CalcNewPoint(p1, p2, nNewX1, nNewY1, m_dAngle);
			sprintf(outbuf, "%d %d %d %d %d %d %d %d\n", nNewX1, nNewY1, p3, p4, p5, p6, p7, p8);  
			if(nNewX1 < nMinX) nMinX = nNewX1;
			if(nNewY1 < nMinY) nMinY = nNewY1;
			tempFile.WriteString((const char*) cs);
			tempFile.WriteString(outbuf); 
			m_pInputFile->ReadString(buffer, 40);    // throw away useless line   
			tempFile.WriteString(buffer);
			continue;			
		}
		if((cs.Left(3) == "CF\n") || (cs.Left(3) == "FF\n"))   // fills ** arrghh! **
		{
			m_pInputFile->ReadString(buffer, 40);
			continue;
		} 
		tempFile.WriteString((const char*) cs);
		
	} while(!bDone); 
	// now to sort out the offset
	nOffsetX = 1000 - nMinX;
	nOffsetY = 1000 - nMinY;

	// return to the start 
	tempFile.Close();
	status = tempFile.Open("~~TEMP.PCB", CFile::modeRead, &exception); 
	status = outFile.Open("OUTPUT.PCB", CFile::modeCreate | CFile::modeWrite, &exception); 
	// scan to create offsets
	bDone = false;
	do
	{
		cs = CString(tempFile.ReadString(buffer, 40));    // ReadString next line
		if(cs.IsEmpty())
			break; 
		if(cs.Find("ENDPCB") >= 0)
			bDone = true; 
		if(bDoNextOne)	// this deals with the reference point of components
		{
			sscanf((const char*) cs, "%d %d %d %d %d", &p1, &p2, &p3, &p4, &p5);
			sprintf(outbuf, "%d %d %d %d %d\n", p1 + nOffsetX, p2 + nOffsetY, p3, p4, p5);
			outFile.WriteString(outbuf); 
			bDoNextOne = FALSE; 
			nSpaceCount = 0;
			continue;
		} 
		if(cs.Left(1) == " ")
		{
			nSpaceCount++;
			if(nSpaceCount == 2)
				bDoNextOne = TRUE;
			sscanf((const char*) cs, " %d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6);
			sprintf(outbuf, " %d %d %d %d %d %d\n", p1 + nOffsetX, p2 + nOffsetY, p3, p4, p5, p6);
			outFile.WriteString(outbuf); 
			continue;
		}			
		if((cs.Left(3) == "CA\n") || (cs.Left(3) == "FA\n"))    // arcs
		{
			tempFile.ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6);  
			sprintf(outbuf, "%d %d %d %d %d %d\n", p1 + nOffsetX, p2 + nOffsetY, p3, p4, p5, p6);  
			outFile.WriteString((const char*) cs);
			outFile.WriteString(outbuf); 
			continue;			
		} 
		if((cs.Left(3) == "CV\n") || (cs.Left(3) == "FV\n"))    // vias
		{
			tempFile.ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d", &p1, &p2, &p3, &p4);
			sprintf(outbuf, "%d %d %d %d\n", p1 + nOffsetX, p2 + nOffsetY, p3, p4);  
			outFile.WriteString((const char*) cs);
			outFile.WriteString(outbuf); 
			continue;			
					
		}
		if((cs.Left(3) == "CT\n") || (cs.Left(3) == "FT\n"))     // tracks
		{		
			tempFile.ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6, &p7);
			sprintf(outbuf, "%d %d %d %d %d %d %d\n", p1 + nOffsetX, p2 + nOffsetY, p3 + nOffsetX, p4 + nOffsetY, p5, p6, p7);  
			outFile.WriteString((const char*) cs);
			outFile.WriteString(outbuf); 
			continue;			
		}
		else if((cs.Left(3) == "CS\n") || (cs.Left(3) == "FS\n"))      // strings
		{
			tempFile.ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6);
			sprintf(outbuf, "%d %d %d %d %d %d\n", p1 + nOffsetX, p2 + nOffsetY, p3, p4, p5, p6);  
			outFile.WriteString((const char*) cs);
			outFile.WriteString(outbuf); 
			tempFile.ReadString(buffer, 40);    // throw away useless line   
			outFile.WriteString(buffer);
			continue;			
		}
		if((cs.Left(3) == "CP\n") || (cs.Left(3) == "FP\n"))
		{
			tempFile.ReadString(buffer, 40);
			sscanf(buffer, "%d %d %d %d %d %d %d %d", &p1, &p2, &p3, &p4, &p5, &p6, &p7, &p8);
			sprintf(outbuf, "%d %d %d %d %d %d %d %d\n", p1 + nOffsetX, p2 + nOffsetY, p3, p4, p5, p6, p7, p8);  
			outFile.WriteString((const char*) cs);
			outFile.WriteString(outbuf); 
			tempFile.ReadString(buffer, 40);    // throw away useless line   
			outFile.WriteString(buffer);
			continue;			
		}
		if((cs.Left(3) == "CF\n") || (cs.Left(3) == "FF\n"))   // fills ** arrghh! **
		{
			tempFile.ReadString(buffer, 40);
			continue;
		} 
		outFile.WriteString((const char*) cs);
		
	} while(!bDone); 
	
	tempFile.Close();
	// delete tempory file
	remove("~~TEMP.PCB");
	outFile.Close();		
	AfxGetApp()->DoWaitCursor(0);
	MessageBeep(-1);	
	return;
}

void CTwist32Dlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	GetDlgItem(IDC_CALCULATE)->EnableWindow(FALSE);
}

void CTwist32Dlg::OnHelpButton() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}
